// Exposed interface to struct db_s. May remove one day, once I set up
// functions to assign data and the function pointers.

#define __DB_T_H__

#ifndef __DB_H__
#include "db.h"
#endif

struct db_s {
  void *data;
  int (*reset)(db_ptr);
  void (*delme)(db_ptr);

  /* Use read_ref for these, until I decide to store all refs in a
   * different manner.
  void *(*read_head_raw)(size_t *len, db_ptr db);
  void (*write_head_raw)(db_ptr db, unsigned char *buf, size_t len);
  */

  // Alternative approach: write and build functions on db_has_file() and
  // db_mmap_file(). They can scrutinize the given filename and call special
  // routines if necessary, e.g. if the path starts with "refs/" or
  // "objects/".
  void *(*mmap_ref_raw)(size_t *len, db_ptr db, const char *ref);
  void (*write_ref_raw)(db_ptr db, const char *ref, void *buf, size_t len);
  int (*has_branch)(db_ptr db, const char *s);
  void (*forall_branches)(db_ptr db, void (*fn)(const char *ref));

  int (*has_object)(db_ptr db, const ID id);
  void *(*mmap_object_raw)(size_t *len, db_ptr db, const ID id);
  void (*write_header_body_raw)(db_ptr db, const ID id,
      const char *header, const unsigned char *buf, size_t len);

  void (*appendlog)(db_ptr db, const ID id, const char *msg);
};
