#define __ID_H__
// requires <stdio.h>

typedef unsigned char ID[20];

void id_cpy(ID dst, const ID src);
void id_fprint(FILE *fp, const ID id);

// Convert from hexadecimal string to 20-byte ID.
// Input string must be at least 40 bytes long.
void id_sread(ID id, const char *s);

void id_fread(ID id, FILE *fp);
void id_sprint(char *s, const ID id);
void id_set0(ID id);
int id_is0(const ID id);
int id_cmp(const ID id1, const ID id2);
void id_header_string(ID id, const char *hdr, const char *s);
void id_header_buflen(ID id, const char *hdr,
    const unsigned char *s, size_t len);
void id_string(ID id, const char *s);

// Hash of buffer.
void id_buflen(ID id, const unsigned char *s, int len);

unsigned char *id_dup(ID src);

enum {
  ID_LEN = 20,   // Length of hash in bytes
  ID_SLEN = 40,  // Length of hash in string form
};
