// Doubly-linked lists.
struct list_node_s {
    struct list_node_s *next, *prev;
    void *data;
};

typedef struct list_node_s *list_node_ptr;
typedef struct list_node_s list_node_t[1];

struct list_s {
    struct list_node_s *first, *last;
    unsigned int count;
};
typedef struct list_s *list_ptr;
typedef struct list_s list_t[1];

typedef list_node_ptr list_it;

void list_init(list_ptr l);
void list_clear(list_ptr l);
void list_clear_with(list_ptr l, void (*fn)(void *));
static inline int list_is_empty(list_ptr l)
{
  return !l->count;
}
void list_insert(list_ptr l, void *data);
void list_append(list_ptr l, void *data);
void *list_remove_last(list_ptr l);
void list_forall(list_ptr l, void (*f)(void *));

static inline list_it list_it_first(list_ptr l) {
  return l->first;
}

static inline list_it list_it_last(list_ptr l) {
  return l->last;
}

static inline list_it list_it_next(list_it it) {
  return it->next;
}

static inline list_it list_it_prev(list_it it) {
  return it->prev;
}

static inline int list_it_is_off(list_it it) {
  return !it;
}

static inline void *list_it_data(list_it it) {
  return it->data;
}
